<?php


namespace Schaffen\Fiscal\NfeDownloader\Services;


use Schaffen\Fiscal\NfeDownloader\Repositories\FileContentRepository;
use Schaffen\Fiscal\NfeDownloader\Repositories\NFeRepository;
use Schaffen\Fiscal\NfeDownloader\Repositories\FileRepository;
use NFePHP\DA\NFe\Danfe;


class DanfeVisualizer
{
    protected NFeRepository $nfe_repository;
    protected FileContentRepository $file_content_repository;
    protected FileRepository $file_repository;

    public function __construct(NFeRepository $nfe_repository, FileContentRepository $file_content_repository,
                                FileRepository $file_repository)
    {
        $this->nfe_repository = $nfe_repository;
        $this->file_content_repository = $file_content_repository;
        $this->file_repository = $file_repository;
    }


    public function getDanfe($id)
    {

        $nfe = $this->nfe_repository->find($id);

        $file = $this->file_repository->find($nfe->nfi_fk_aim_codigo);
        $xml = $this->xmlDecode($this->file_content_repository->find($file->aim_fk_cxm_codigo)->cxm_conteudo);

        $danfe = new Danfe($xml);
        $pdf = $danfe->render();
        header('Content-Type: application/pdf');
        echo $pdf;

    }

    public function xmlDecode($xml_encoded)
    {
        return gzdecode(base64_decode(stream_get_contents($xml_encoded)));
    }

}
